#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;
#define int long long

typedef tree <int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int h[100010], mx[400010], pr[400010], suf[400010], mod1[400010], mod2[400010], len[100010], arr[100010];


void push1 (int v, int l, int r, int m) {
    if (mod1[v] != 0) {
        mod1[v*2] = mod1[v];
        mod1[v*2+1] = mod1[v];
        pr[v*2] = mod1[v*2]*(m-l+1);
        pr[v*2+1] = mod1[v*2+1]*(r-m);
        mod1[v] = 0;
    }
}

void push2 (int v, int l, int r, int m) {
    if (mod2[v] != 0) {
        mod2[v*2] = mod2[v];
        mod2[v*2+1] = mod2[v];
        suf[v*2] = mod2[v*2]*(m-l+1);
        suf[v*2+1] = mod2[v*2+1]*(r-m);
        mod2[v] = 0;
    }
}

void build (int v, int l, int r) {
    if (l == r) {
        pr[v] = h[l];
        suf[v] = h[l];
        mx[v] = h[l];
        return;
    }
    int m = (l+r)/2;
    build(v*2, l, m);
    build(v*2+1, m+1, r);
    suf[v] = suf[v*2] + suf[v*2+1];
    pr[v] = pr[v*2] + pr[v*2+1];
    mx[v] = max(mx[v*2], mx[v*2+1]);
}

void updatepr (int v, int l, int r, int x, int y, int z) {
    if (l == x && r == y) {
        mod1[v] = z;
        pr[v] = z * (r-l+1);
        return;
    }
    int m = (l+r)/2;
    push1(v, l, r, m);
    if (y <= m) {
        updatepr(v*2, l, m, x, y, z);
    } else if (x > m) {
        updatepr(v*2+1, m+1, r, x, y, z);
    } else {
        updatepr(v*2, l, m, x, m, z);
        updatepr(v*2+1, m+1, r, m+1, y, z);
    }
    pr[v] = pr[v*2] + pr[v*2+1];
}

void updatesuf (int v, int l, int r, int x, int y, int z) {
    if (l == x && r == y) {
        mod2[v] = z;
        suf[v] = z * (r-l+1);
        return;
    }
    int m = (l+r)/2;
    push2(v, l, r, m);
    if (y <= m) {
        updatesuf(v*2, l, m, x, y, z);
    } else if (x > m) {
        updatesuf(v*2+1, m+1, r, x, y, z);
    } else {
        updatesuf(v*2, l, m, x, m, z);
        updatesuf(v*2+1, m+1, r, m+1, y, z);
    }
    suf[v] = suf[v*2] + suf[v*2+1];
}

int getmx (int v, int l, int r, int x, int y) {
    if (l == x && r == y) {
        return mx[v];
    }
    int m = (l+r)/2;
    if (y <= m) {
        return getmx(v*2, l, m, x, y);
    } else if (x > m) {
        return getmx(v*2+1, m+1, r, x, y);
    } else {
        return max(getmx(v*2, l, m, x, m), getmx(v*2+1, m+1, r, m+1, y));
    }
}

int getpr (int v, int l, int r, int x, int y) {
    if (l == x && r == y) {
        return pr[v];
    }
    int m = (l+r)/2;
    push1(v, l, r, m);
    if (y <= m) {
        return getpr(v*2, l, m, x, y);
    } else if (x > m) {
        return getpr(v*2+1, m+1, r, x, y);
    } else {
        return getpr(v*2, l, m, x, m) + getpr(v*2+1, m+1, r, m+1, y);
    }
}

int getsuf (int v, int l, int r, int x, int y) {
    if (l == x && r == y) {
        return suf[v];
    }
    int m = (l+r)/2;
    push2(v, l, r, m);
    if (y <= m) {
        return getsuf(v*2, l, m, x, y);
    } else if (x > m) {
        return getsuf(v*2+1, m+1, r, x, y);
    } else {
        return getsuf(v*2, l, m, x, m) + getsuf(v*2+1, m+1, r, m+1, y);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    ordered_set s;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        len[i] = 1;
        arr[i] = h[i];
        s.insert(i);
    }
    int k;
    s.insert(n);
    build(1, 0, n-1);
    for (int j = 0; j < n-1; j++) {
        cin >> k;
        int l1 = *s.find_by_order(k-1), l2 = *s.find_by_order(k);
        int r1 = l1+len[l1]-1, r2 = l2+len[l2]-1;
        int mx1 = getmx(1, 0, n-1, l1, r1), mx2 = getmx(1, 0, n-1, l2, r2);
        int l = l1-1, r = r1+1;
        while (r > l+1) {
            int m = (l+r)/2;
            if (getmx(1, 0, n-1, m, r1) > mx2) {
                l = m;
            } else {
                r = m;
            }
        }
        int x = r;
        if (r1 >= x) {
            updatesuf(1, 0, n-1, x, r1, mx2);
        }

        l = l2-1, r = r2+1;
        while (r > l+1) {
            int m = (l+r)/2;
            if (getmx(1, 0, n-1, l2, m) >= mx1) {
                r = m;
            } else {
                l = m;
            }
        }
        x = l;
        if (l2 <= x) {
            updatepr(1, 0, n-1, l2, x, mx1);
        }

        l = l1, r = r2+1;
        while (r > l+1) {
            int m = (l+r)/2;
            if (getmx(1, 0, n-1, l1, m) <= getmx(1, 0, n-1, m, r2)) {
                l = m;
            } else {
                r = m;
            }
        }
        int ans = 0;
        ans += getpr(1, 0, n-1, l1, l);
        if (l+1 <= r2) {
            ans += getsuf(1, 0, n-1, l+1, r2);
        }
        cout << ans - arr[l1] - arr[l2] << '\n';
        arr[l1]+=arr[l2];
        len[l1] += len[l2];
        s.erase(l2);
    }
    return 0;
}